import de.raida.cad.dex.CADExportContainer;
import de.raida.cad.dex.cadexport.jt.JTExporterImplementation;
import de.raida.cad.dex.cadimport.bgf.BGFImporterImplementation;
import de.raida.cad.dex.interfaces.CADExportInterface;
import de.raida.cad.dex.interfaces.CADImportInterface;

/**
 * Example class for converting a CAD file into another format.
 * @author  <a href="mailto:j.raida@gmx.net">Johannes Raida</a>
 * @version 1.0
 */
public class ExportJT {
	/**
	 * Constructor, creating the scene.
	 * @param fileName File name
	 */
	public ExportJT(String fileName){
		try {
			// Load a BGF file
			CADImportInterface cadImportInterface = new BGFImporterImplementation();
			cadImportInterface.importFile(fileName, null);

			// Write the JT file
			CADExportInterface cadExportInterface = new JTExporterImplementation();
			cadExportInterface.exportFile(fileName + ".jt", new CADExportContainer(cadImportInterface, fileName), null);
			
		} catch(Exception exception){
			exception.printStackTrace();
		}
	}

	/**
	 * Entry point of the class
	 * @param arguments Arguments, given by the command line
	 */
	public static void main(String[] arguments){
		if(arguments.length != 1){
			System.out.println("Wrong number of parameter!");
			System.out.println("Usage: java ExportJT <BGF file>");
			return;
		}

		new ExportJT(arguments[0]);
	}
}